# ResumableFunctions

<table>
    <tr>
        <td>Documentation</td>
        <td>
            <a href="https://juliadynamics.github.io/ResumableFunctions.jl/stable"><img src="https://img.shields.io/badge/docs-stable-blue.svg" alt="Documentation of latest stable version"></a>
            <a href="https://juliadynamics.github.io/ResumableFunctions.jl/dev"><img src="https://img.shields.io/badge/docs-dev-blue.svg" alt="Documentation of dev version"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Continuous integration</td>
        <td>
            <a href="https://github.com/JuliaDynamics/ResumableFunctions.jl/actions?query=workflow%3ACI+branch%3Amaster"><img src="https://img.shields.io/github/actions/workflow/status/JuliaDynamics/ResumableFunctions.jl/ci.yml?branch=master" alt="GitHub Workflow Status"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Code coverage</td>
        <td>
            <a href="https://codecov.io/gh/JuliaDynamics/ResumableFunctions.jl"><img src="https://img.shields.io/codecov/c/gh/JuliaDynamics/ResumableFunctions.jl?label=codecov" alt="Test coverage from codecov"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Static analysis with</td>
        <td>
            <a href="https://github.com/aviatesk/JET.jl"><img src="https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a" alt="JET static analysis"></a>
            <a href="https://github.com/JuliaTesting/Aqua.jl"><img src="https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg" alt="Aqua QA"></a>
        </td>
    </tr>
</table>

[![status](http://joss.theoj.org/papers/889b2faed426b978ee705689c8f8440b/status.svg)](http://joss.theoj.org/papers/889b2faed426b978ee705689c8f8440b)
[![DOI](https://zenodo.org/badge/100050892.svg)](https://zenodo.org/badge/latestdoi/100050892)

[C#](https://docs.microsoft.com/en-us/dotnet/csharp/language-reference/) has a convenient way to create iterators using the `yield return` statement. The package `ResumableFunctions` provides the same functionality for the [Julia language](https://julialang.org) by introducing the `@resumable` and the `@yield` macros. These macros can be used to replace the `Task` switching functions `produce` and `consume` which were deprecated in Julia v0.6. `Channels` are the preferred way for inter-task communication in julia v0.6+, but their performance is subpar for iterator applications. See [the benchmarks section below](#Benchmarks).

## Installation

`ResumableFunctions` is a [registered package](http://pkg.julialang.org) and can be installed by running:
```julia
using Pkg
Pkg.add("ResumableFunctions")
```

##  Example

```julia
using ResumableFunctions

@resumable function fibonacci(n::Int) :: Int
  a = 0
  b = 1
  for i in 1:n
    @yield a
    a, b = b, a+b
  end
end

for fib in fibonacci(10)
  println(fib)
end
```

```julia
# Example which specifies the length
using ResumableFunctions

@resumable length=n^2 function fibonacci(n::Int) :: Int
  a = 0
  b = 1
  for i in 1:n^2
    @yield a
    a, b = b, a+b
  end
end

for fib in fibonacci(5)
  println(fib)
end
```

## Benchmarks
The following block is the result of running `julia --project=. benchmark/benchmarks.jl` on a Macbook Pro with following processor: `Intel Core i9 2.4 GHz 8-Core`. Julia version 1.5.3 was used.

Fibonacci with `Int` values:

```
Direct: 
  27.184 ns (0 allocations: 0 bytes)
ResumableFunctions: 
  27.503 ns (0 allocations: 0 bytes)
Channels csize=0: 
  2.438 ms (101 allocations: 3.08 KiB)
Channels csize=1: 
  2.546 ms (23 allocations: 1.88 KiB)
Channels csize=20: 
  138.681 μs (26 allocations: 2.36 KiB)
Channels csize=100: 
  35.071 μs (28 allocations: 3.95 KiB)
Task scheduling
  17.726 μs (86 allocations: 3.31 KiB)
Closure: 
  1.948 μs (82 allocations: 1.28 KiB)
Closure optimised: 
  25.910 ns (0 allocations: 0 bytes)
Closure statemachine: 
  28.048 ns (0 allocations: 0 bytes)
Iteration protocol: 
  41.143 ns (0 allocations: 0 bytes)
```

Fibonacci with `BigInt` values:

```
Direct: 
  5.747 μs (188 allocations: 4.39 KiB)
ResumableFunctions: 
  5.984 μs (191 allocations: 4.50 KiB)
Channels csize=0: 
  2.508 ms (306 allocations: 7.75 KiB)
Channels csize=1: 
  2.629 ms (306 allocations: 7.77 KiB)
Channels csize=20: 
  150.274 μs (309 allocations: 8.25 KiB)
Channels csize=100: 
  44.592 μs (311 allocations: 9.84 KiB)
Task scheduling
  24.802 μs (198 allocations: 6.61 KiB)
Closure: 
  7.064 μs (192 allocations: 4.47 KiB)
Closure optimised: 
  5.809 μs (190 allocations: 4.44 KiB)
Closure statemachine: 
  5.826 μs (190 allocations: 4.44 KiB)
Iteration protocol: 
  5.822 μs (190 allocations: 4.44 KiB)
```

## Authors

* Ben Lauwens, [Royal Military Academy](http://www.rma.ac.be), Brussels, Belgium.
* JuliaDynamics and QuantumSavory volunteers.

## Contributing

* To discuss problems or feature requests, file an issue. For bugs, please include as much information as possible, including operating system, julia version, and version of [MacroTools](https://github.com/MikeInnes/MacroTools.jl.git).
* To contribute, make a pull request. Contributions should include tests for any new features/bug fixes.

## Release Notes

A [detailed change log is kept](https://github.com/JuliaDynamics/ResumableFunctions.jl/blob/master/CHANGELOG.md).

## Caveats

* In a `try` block only top level `@yield` statements are allowed.
* In a `finally` block a `@yield` statement is not allowed.
* An anonymous function can not contain a `@yield` statement.
* `@isdefined` can not be used in a resumable function.
* Many more restrictions.

#= The Computer Language Benchmarks Game
   https://salsa.debian.org/benchmarksgame-team/benchmarksgame/

   contributed by Ben Lauwens

   derived from the Chapel version by Tom Hildebrandt, Brad Chamberlain, and Lydia Duncan
   and inspired by the Julia version of Luiz M. Faria
=#

using ResumableFunctions

using Base.GMP.MPZ: add_ui!, mul_ui!, add!, tdiv_q!
const mpz_t = Ref{BigInt}
addmul_ui!(x::BigInt,a::BigInt,b::UInt64) = ccall((:__gmpz_addmul_ui,"libgmp"), Cvoid, (mpz_t,mpz_t,Culong), x, a, b)
submul_ui!(x::BigInt,a::BigInt,b::UInt64) = ccall((:__gmpz_submul_ui,"libgmp"), Cvoid, (mpz_t,mpz_t,Culong), x, a, b)
get_ui(x::BigInt) = ccall((:__gmpz_get_ui,"libgmp"), Culong, (mpz_t,), x)

@resumable function pidigits()
    k = one(UInt64)
    d = zero(UInt64)
    numer = BigInt(1)
    denom = BigInt(1)
    accum = BigInt(0)
    tmp1 = BigInt(0)
    tmp2 = BigInt(0)
    tmp3 = BigInt(0)
    while true
        k2 = 2k + one(UInt64)
        addmul_ui!(accum, numer, UInt64(2))
        mul_ui!(accum, k2)
        mul_ui!(denom, k2)
        mul_ui!(numer, k)
        k += one(UInt64)
        if numer <= accum
            mul_ui!(tmp1, numer, UInt64(3))
            add!(tmp1, accum)
            tdiv_q!(tmp2, tmp1, denom)
            mul_ui!(tmp1, numer, UInt64(4))
            add!(tmp1, accum)
            tdiv_q!(tmp3, tmp1, denom)
            if tmp2 == tmp3
                d = get_ui(tmp2)
                @yield d
                submul_ui!(accum, denom, d)
                mul_ui!(accum, UInt64(10))
                mul_ui!(numer, UInt64(10))
            end
        end
    end
end

function main(n = parse(Int64, ARGS[1]))
    i = 0
    pid = pidigits()
    for i in 1:n
        d = pid()
        print(d)
        if i % 10 === 0
            println("\t:", i)
        end
    end
    if i % 10 !== 0
        println(" "^(10 - (i % 10)), "\t:", n)
    end
end


main(100)

using Documenter
using ResumableFunctions

@testset "Doctests" begin
    DocMeta.setdocmeta!(ResumableFunctions, :DocTestSetup, :(using ResumableFunctions); recursive=true)
    doctest(ResumableFunctions)
end

"""
Macro if used in a `@resumable function` that returns the `expr` otherwise throws an error.
"""
macro yield(expr=nothing)
  error("@yield macro outside a @resumable function!")
end

"""
Macro if used in a `@resumable function` that delegates to `expr` otherwise throws an error.
"""
macro yieldfrom(expr=nothing)
  error("@yieldfrom macro outside a @resumable function!")
end

"""
Macro if used in a `@resumable function` that creates a not saved variable otherwise throws an error.
"""
macro nosave(expr=nothing)
  error("@nosave macro outside a @resumable function!")
end

"""
Macro that transforms a function definition in a finite-state machine:

- Defines a new `mutable struct` that implements the iterator interface and is used to store the internal state.
- Makes this new type callable having following characteristics:
  - implementents the statements from the initial function definition but;
  - returns at a `@yield` statement and;
  - continues after the `@yield` statement when called again.
- Defines a constructor function that respects the calling conventions of the initial function definition and returns an object of the new type.

If the element type and length is known, the resulting iterator can be made
more efficient as follows:
- Use `length=ex` to specify the length (if known) of the iterator, like:
    @resumable length=ex function f(x); body; end
  Here `ex` can be any expression containing the arguments of `f`.
- Use `function f(x)::T` to specify the element type of the iterator.

# Extended

```julia
julia> @resumable length=n^2 function f(n)::Int
         for i in 1:n^2
           @yield i
         end
       end
f (generic function with 2 methods)

julia> collect(f(3))
9-element Vector{Int64}:
 1
 2
 3
 4
 5
 6
 7
 8
 9
```
"""
macro resumable(ex::Expr...)
  length(ex) >= 3 && throw(ArgumentError("Too many arguments"))
  for i in 1:length(ex)-1
    a = ex[i]
    if !(a isa Expr && a.head === :(=) && a.args[1] in [:length])
      throw(ArgumentError("only keyword argument 'length' allowed, got `$a` instead"))
    end
  end

  expr = ex[end]
  expr.head !== :function && throw(ArgumentError("Expression `$expr` is not a function definition!"))

  # The function that executes a step of the finite state machine
  func_def = splitdef(expr)
  @debug func_def[:body] |> striplines
  rtype = :rtype in keys(func_def) ? func_def[:rtype] : Any
  args, kwargs, arg_dict = get_args(func_def)
  params = ((get_param_name(param) for param in func_def[:whereparams])...,)

  # Initial preparation of the function stepping through the finite state machine,
  # and extraction of local variables and their types
  ui8 = BoxedUInt8(zero(UInt8))
  func_def[:body] = postwalk(transform_arg_yieldfrom, func_def[:body])
  func_def[:body] = postwalk(transform_yieldfrom, func_def[:body])
  func_def[:body] = postwalk(x->transform_for(x, ui8), func_def[:body])
  @debug func_def[:body] |> striplines

  # Scoping fixes

  # :name is :(fA::A) if it is an overloading call function (fA::A)(...)
  # ...
  if func_def[:name] isa Expr
    func_def[:name].head != :(::) && error("Unrecognized function name: $(func_def[:name].head)")
    _name = func_def[:name].args[1]
  else
    _name = func_def[:name]
  end

  scope = ScopeTracker(0, __module__, [Dict(i =>i for i in vcat(args, kwargs, [_name], params...))])
  func_def[:body] = scoping(copy(func_def[:body]), scope)
  func_def[:body] = postwalk(x->transform_remove_local(x), func_def[:body])
  @debug func_def[:body] |> striplines

  inferfn, slots = get_slots(copy(func_def), arg_dict, __module__)
  @debug slots

  # check if the resumable function is a callable struct instance (a functional) that is referencing itself
  isfunctional = @capture(func_def[:name], functional_::T_) && inexpr(func_def[:body], functional)
  if isfunctional
    slots[functional] = T
  else
    functional = :var"#self#"
  end
  pushfirst!(args, functional)

  # The finite state machine structure definition
  type_name = fresh_binding_name(Symbol(func_def[:name], :_FSMI))
  constr_def = copy(func_def)
  slot_T = [gensym(s) for s in keys(slots)]
  slot_T_sub = [:($k <: $v) for (k, v) in zip(slot_T, values(slots))]
  struct_name = :($type_name{$(func_def[:whereparams]...), $(slot_T_sub...)} <: ResumableFunctions.FiniteStateMachineIterator{$rtype})
  constr_def[:whereparams] = (func_def[:whereparams]..., slot_T_sub...)

  # if there are no where or slot type parameters, we need to use the bare type
  if isempty(params) && isempty(slot_T)
    constr_def[:name] = :($type_name)
  else
    constr_def[:name] = :($type_name{$(params...), $(slot_T...)})
  end
  constr_def[:args] = tuple()
  constr_def[:kwargs] = tuple()
  constr_def[:rtype] = nothing
  constr_def[:body] = quote
    fsmi = new()
    fsmi._state = 0x00
    fsmi
  end
  # the bare/fallback version of the constructor supplies default slot type parameters
  # we only need to define this if there there are actually slot defaults to be filled
  if !isempty(slot_T)
    bareconstr_def = copy(constr_def)
    if isempty(params)
      bareconstr_def[:name] = :($type_name)
    else
      bareconstr_def[:name] = :($type_name{$(params...)})
    end
    bareconstr_def[:whereparams] = func_def[:whereparams]
    bareconstr_def[:body] = :($(bareconstr_def[:name]){$(values(slots)...)}())
    bareconst_expr = combinedef(bareconstr_def) |> flatten
  else
    bareconst_expr = nothing
  end
  constr_expr = combinedef(constr_def) |> flatten
  typed_fsmi = VERSION >= v"1.10.0-DEV.873" ? fresh_binding_name(:typed_fsmi) : typed_fsmi_fallback
  type_expr = quote
    mutable struct $struct_name
      _state :: UInt8
      $((:($slotname :: $slottype) for (slotname, slottype) in zip(keys(slots), slot_T))...)
      $(constr_expr)
      $(bareconst_expr)
    end
    # JuliaLang/julia#48611: world age is exposed to generated functions, and should be used
    if VERSION >= v"1.10.0-DEV.873"
      # This is like @generated, but it receives the world age of the caller
      # which we need to do inference safely and correctly
      function $typed_fsmi(fsmi, fargs...)
          $(Expr(:meta, :generated_only))
          $(Expr(:meta, :generated, FSMIGenerator(inferfn)))
      end
    end
  end
  @debug type_expr |> striplines
  # The "original" function that now is simply a wrapper around the construction of the finite state machine
  call_def = copy(func_def)
  call_def[:rtype] = nothing
  if isempty(params)
    fsmi_name = type_name
  else
    fsmi_name = :($type_name{$(params...)})
  end
  fwd_args, fwd_kwargs = forward_args(call_def)
  call_def[:body] = quote
    fsmi = $typed_fsmi($fsmi_name, $functional, $(fwd_args...), $(fwd_kwargs...))
    $((arg !== :_ && arg !== :var"#self#" ? :(fsmi.$arg = $arg) : nothing for arg in args)...)
    $((:(fsmi.$arg = $arg) for arg in kwargs)...)
    fsmi
  end
  call_expr = combinedef(call_def) |> flatten
  @debug call_expr |> striplines

  # Finalizing the function stepping through the finite state machine
  if isempty(params)
    func_def[:name] = :((_fsmi::$type_name))
  else
    func_def[:name] = :((_fsmi::$type_name{$(params...)}))
  end
  func_def[:rtype] = nothing
  func_def[:body] = postwalk(x->transform_slots(x, keys(slots)), func_def[:body])

  # Capture the length=...
  interface_defs = []
  for i in 1:length(ex)-1
    a = ex[i]
    if !(a isa Expr && a.head === :(=) && a.args[1] in [:length])
      error("only keyword argument 'length' allowed")
    end
    if a.args[1] === :length
      push!(interface_defs, quote Base.IteratorSize(::Type{<: $type_name}) = Base.HasLength() end)
      func_def2 = copy(func_def)
      func_def2[:body] = a.args[2]
      new_body = postwalk(x->transform_slots(x, keys(slots)), a.args[2])
      push!(interface_defs, quote Base.length(_fsmi::$type_name) = begin $new_body end end)
    end
  end

  func_def[:body] = postwalk(transform_arg, func_def[:body])
  func_def[:body] = postwalk(transform_exc, func_def[:body]) |> flatten
  ui8 = BoxedUInt8(zero(UInt8))
  func_def[:body] = postwalk(x->transform_try(x, ui8), func_def[:body])
  ui8 = BoxedUInt8(zero(UInt8))
  func_def[:body] = postwalk(x->transform_yield(x, ui8), func_def[:body])
  func_def[:body] = postwalk(x->transform_nosave(x, Set{Symbol}()), func_def[:body])
  func_def[:body] = quote
    _fsmi._state === 0x00 && @goto _STATE_0
    $((:(_fsmi._state === $i && @goto $(Symbol("_STATE_",i))) for i in 0x01:ui8.n)...)
    error("@resumable function has stopped!")
    @label _STATE_0
    _fsmi._state = 0xff
    _arg isa Exception && throw(_arg)
    $(func_def[:body])
  end
  func_def[:args] = [Expr(:kw, :(_arg::Any), nothing)]
  func_def[:kwargs] = []
  func_expr = combinedef(func_def) |> flatten

  if inexpr(func_def[:body], call_def[:name]) || isfunctional
    @debug "recursion or self-reference is present in a resumable function definition: falling back to no inference"
    call_expr = postwalk(x->x===typed_fsmi ? :(ResumableFunctions.typed_fsmi_fallback) : x, call_expr)
  end
  @debug func_expr |> striplines
  # The final expression:
  # - the finite state machine struct
  # - the function stepping through the states
  # - the "original" function which now is a simple wrapper around the construction of the finite state machine
  esc(quote
    $type_expr
    $func_expr
    $(interface_defs...)
    Base.@__doc__($call_expr)
  end)
end

using Test
using ResumableFunctions

##

@resumable function rec1(a::Int)::Int
    @yield a
    if a > 0
        for i in rec1(a-1)
            @yield i
        end
    end
end
@test collect(rec1(4)) isa Vector{Int}
@test collect(rec1(4)) == 4:-1:0

##

@resumable function rec2(a::Int)::Any
    @yield a
    if a > 0
        for i in rec2(a-1)
            @yield i
        end
    end
end
@test collect(rec2(4)) isa Vector{Any}
@test collect(rec2(4)) == 4:-1:0

##

@resumable function rec3(a)
    @yield a
    if a > 0
        for i in rec3(a-1)
            @yield i
        end
    end
end
@test collect(rec3(4)) isa Vector{Any}
@test collect(rec3(4)) == 4:-1:0

##

# From issue #80

@resumable function rf!(a::Vector{Int}, i::Integer, n::Integer)::Vector{Int}
    if i > n
        @yield a
        return
    end
    a[i] = 0
    for _ in rf!(a, i+1, n)
        @yield a
    end
    for k = i+1:n
        a[i] = k
        a[k] = i
        for _ in rf!(a, i+1, k-1)
            for _ in rf!(a, k+1, n)
            @yield a
            end
        end
    end
end

const n = 3
const a = zeros(Int, n)
collect(rf!(a, 1, n)) == [[3, 0, 1],
                          [3, 0, 1],
                          [3, 0, 1],
                          [3, 0, 1]]

"""
Abstract type used as base type for the type created by the `@resumable` macro.
"""
abstract type FiniteStateMachineIterator{R} end

"""
Mutable struct that contains a single `UInt8`.
"""
mutable struct BoxedUInt8
  n :: UInt8
end

"""
Implements the `iteratorsize` method of the *iterator* interface for a subtype of `FiniteStateMachineIterator`.
"""
Base.IteratorSize(::Type{T}) where T<:FiniteStateMachineIterator = Base.SizeUnknown()

"""
Implements the `eltype` method of the *iterator* interface for a subtype of `FiniteStateMachineIterator`.
"""
Base.eltype(::Type{T}) where T<:FiniteStateMachineIterator{R} where R = R

function Base.iterate(fsm_iter::FiniteStateMachineIterator, state=nothing)
   result = fsm_iter()
   fsm_iter._state === 0xff && return nothing
   result, nothing
end

using Test
using ResumableFunctions

# From issue #86

##

@resumable function singleton()::String
    @yield "anything"
end

# 1. must be defined before combined!
@resumable function _empty(x)::String
end

@resumable function combined()::String
    for s in singleton()
        @yield s # fails "here" because s is determined to be of type Nothing because of the second loop
    end
    # 2. must reuse of variable
    for s in _empty(1) # dummy argument needed to illustrate point 1.
        @yield s
    end
end

@test collect(combined()) == ["anything"]
@test collect(combined()) isa Vector{String}

##

@resumable function singletonF()::String
    @yield "anything"
end

@resumable function _emptyF()::String
end

@resumable function combinedF()::String
    # @yieldfrom also uses the same variable names for each generated loop
    @yieldfrom singletonF()
    @yieldfrom _emptyF()
end

@test collect(combinedF()) == ["anything"]
@test collect(combinedF()) isa Vector{String}

"""
Main module for ResumableFunctions.jl – C# style generators a.k.a. semi-coroutines for Julia
"""
module ResumableFunctions

using MacroTools: striplines, @capture, flatten, postwalk, inexpr
using MacroTools: combinedef, splitdef, combinearg, splitarg

export @resumable, @yield, @nosave, @yieldfrom

include("safe_logging.jl")

include("types.jl")
include("transforms.jl")
include("utils.jl")
include("macro.jl")

end

"""
Function returning the name of a `where` parameter
"""
function get_param_name(expr) :: Symbol
  @capture(expr, arg_<:arg_type_) && return arg
  @capture(expr, arg_) && return arg
end

"""
Function returning the arguments of a function definition
"""
function get_args(func_def::Dict)
  arg_dict = Dict{Symbol, Any}()
  arg_list = Vector{Symbol}()
  kwarg_list = Vector{Symbol}()
  for arg in (func_def[:args]...,)
    arg_def = splitarg(arg)
    if arg_def[1] !== nothing
      push!(arg_list, arg_def[1])
      arg_dict[arg_def[1]] = arg_def[3] ? Any : arg_dict[arg_def[1]] = arg_def[2]
    end
  end
  for arg in (func_def[:kwargs]...,)
    arg_def = splitarg(arg)
    push!(kwarg_list, arg_def[1])
    arg_dict[arg_def[1]] = arg_def[3] ? Any : arg_dict[arg_def[1]] = arg_def[2]
  end
  arg_list, kwarg_list, arg_dict
end

"""
Takes a function definition and returns the expressions needed to forward the arguments to an inner function.
For example `function foo(a, ::Int, c...; x, y=1, z...)` will
1. modify the function to `gensym()` nameless arguments
2. return `(:a, gensym(), :(c...)), (:x, :y, :(z...)))`
"""
function forward_args(func_def)
  args = []
  map!(func_def[:args], func_def[:args]) do arg
    name, type, splat, default = splitarg(arg)
    name = something(name, gensym())
    if splat
      push!(args, :($name...))
    else
      push!(args, name)
    end
    combinearg(name, type, splat, default)
  end
  kwargs = []
  for arg in func_def[:kwargs]
    name, type, splat, default = splitarg(arg)
    if splat
      push!(kwargs, :($name...))
    else
      push!(kwargs, name)
    end
  end
  args, kwargs
end

const unused = (Symbol("#temp#"), Symbol("_"), Symbol(""), Symbol("#unused#"), Symbol("#self#"))
const fresh_binding_counter = Base.Threads.Atomic{UInt}(0)

# JET/Revise can replay macro expansion in a way that makes plain `gensym()`
# collide for top-level bindings. Use an explicit module-global counter there.
function fresh_binding_name(prefix=:resumable)
  id = Base.Threads.atomic_add!(fresh_binding_counter, UInt(1)) + UInt(1)
  return Symbol("##", prefix, "#", Base.get_world_counter(), "#", id)
end

function strip_defaults(arg_exprs::Vector{Any})
  return Any[@capture(arg_expr, arg_expr2_ = default_) ? arg_expr2 : arg_expr
    for arg_expr in arg_exprs]
end

"""
Function returning the slots of a function definition
"""
function get_slots(func_def::Dict, args::Dict{Symbol, Any}, mod::Module)
  slots = Dict{Symbol, Any}()
  func_def[:name] = fresh_binding_name(:inferfn)
  func_def[:args] = Any[strip_defaults(func_def[:args])..., strip_defaults(func_def[:kwargs])...]
  func_def[:kwargs] = []
  # replace yield with inference barrier
  func_def[:body] = postwalk(transform_yield, func_def[:body])
  # collect items to skip
  nosaves = Set{Symbol}()
  func_def[:body] = postwalk(x->transform_nosave(x, nosaves), func_def[:body])
  # eval function
  func_expr = combinedef(func_def) |> flatten
  inferfn = @eval(mod, @noinline $func_expr)
  #@info func_def[:body] |> striplines
  # get typed code
  m = only(methods(inferfn, Tuple))
  codeinfo = only(code_typed(inferfn, Tuple; optimize=false))
  #@info codeinfos
  # extract slot names and types
  for (name, type) in collect(zip(codeinfo.first.slotnames, codeinfo.first.slottypes))
    name ∉ nosaves && name ∉ unused && (slots[name] = Union{type, get(slots, name, Union{})})
  end
  # remove `catch exc` statements
  postwalk(x->remove_catch_exc(x, slots), func_def[:body])
  # set error branches to `Any`
  for (key, val) in slots
    if val === Union{}
      slots[key] = Any
    end
  end
  return m, slots
end

"""
Function removing the `exc` symbol of a `catch exc` statement of a list of slots.
"""
function remove_catch_exc(expr, slots::Dict{Symbol, Any})
  @capture(expr, (try body__ catch exc_; handling__ end) | (try body__ catch exc_; handling__ finally always__ end)) && delete!(slots, exc)
  expr
end

struct IteratorReturn{T}
  value :: T
  IteratorReturn(value) = new{typeof(value)}(value)
end

@inline function generate(fsm_iter::FiniteStateMachineIterator, send, state=nothing)
  #fsm_iter._state = state
  result = fsm_iter(send)
  fsm_iter._state === 0xff && return IteratorReturn(result)
  result, nothing
end

@inline function generate(iter, _)
  ret = iterate(iter)
  isnothing(ret) && return IteratorReturn(nothing)
  ret
end

@inline function generate(iter, _, state)
  ret = iterate(iter, state)
  isnothing(ret) && return IteratorReturn(nothing)
  ret
end

struct FSMIGenerator
  m::Method
end

intersection_env(@nospecialize(x), @nospecialize(y)) = ccall(:jl_type_intersection_with_env, Any, (Any,Any), x, y)::Core.SimpleVector

@static if VERSION >= v"1.12" # static macro prevents JET/Revise from making mistakes here when analyzing the file
  using Base: invoke_in_typeinf_world
else
  function invoke_in_typeinf_world(args...)
    vargs = Any[args...]
    return ccall(:jl_call_in_typeinf_world, Any, (Ptr{Any}, Cint), vargs, length(vargs))
  end
end

function code_typed_by_method(method::Method, @nospecialize(tt::Type), world::UInt)
  # run inference (TODO: not really allowed or safe in a generated function)
  (ti, sparams) = intersection_env(tt, method.sig)
  interp = Core.Compiler.NativeInterpreter(world)
  frame = invoke_in_typeinf_world(Core.Compiler.typeinf_frame, interp, method, tt, sparams::Core.SimpleVector, false)
  frame === nothing && error("inference failed")
  ci = frame.src
  @static if VERSION >= v"1.12"
    ci.edges = Core.svec(frame.edges...) # Core.Compiler seems to forget to do this
  end
  return frame.linfo, ci
end

function (fsmi_generator::FSMIGenerator)(world::UInt, source, typed_fsmitype, fsmitype::Type{Type{T_}}, fargtypes) where T_
    @nospecialize
    # get typed code of the inference function evaluated in get_slots
    # using the concrete argument types
    T = T_
    m = fsmi_generator.m
    stub = Core.GeneratedFunctionStub(identity, Core.svec(:var"#self#", :fsmi, :fargs), Core.svec())
    fargtypes = Tuple{fargtypes...} # convert (types...) to Tuple{types...}
    mi, ci = try
      code_typed_by_method(m, fargtypes, world)
    catch err # inference failed, return generic type
      @safe_warn "Inference of a @resumable function failed -- a slower fallback will be used and everything will still work, however please consider reporting this to the developers of ResumableFunctions.jl so that we can debug and increase performance"
      @safe_warn "The error was $err"
      return stub(world, source, :(return $T())) # use typed_fsmi_fallback implementation
    end
    # extract slot types
    cislots = Dict{Symbol, Any}()
    names = ci.slotnames
    types = ci.slottypes
    for i in eachindex(names)
      # take care to widen types that are unstable or Const
      name = names[i]
      type = Core.Compiler.widenconst(types[i])
      cislots[name] = Union{type, get(cislots, name, Union{})}
    end
    slots = map(slot->get(cislots, slot, Any), fieldnames(T)[2:end])
    # instantiate the concrete type
    if !isempty(slots)
      T = T{slots...}
    end
    new_ci = stub(world, source, :(return $T()))
    edges = ci.edges
    if edges !== nothing && !isempty(edges)
      # Inference may have conservatively limited the world range, even though it also concluded there was no restrictions (hence no edges) necessary.
      new_ci.min_world = ci.min_world
      new_ci.max_world = ci.max_world
      new_ci.edges = edges
    end
    return new_ci
end

# a fallback function that uses the fallback constructor with generic slot types
# useful for older versions of Julia or for situations where our current custom inference struggles
function typed_fsmi_fallback(fsmi::Type{T}, fargs...)::T where T
  return T()
end

################################################################################
#
#  Scoping
#
################################################################################

# As every modern programming language, julia has the concept of variable scope,
# see https://docs.julialang.org/en/v1/manual/variables-and-scoping/.
#
# For example, in the following example, there are actual two variables.
# This can be seen by rewriting this as on the right hand side.
#
# a = 1         | a_1 = 1
# let a = a     | begin
#   a = 2       |   a_2 = a_1; a_2 = 2
# end           | end
#
# A similar phenomen happens with `local`
#
# x = 1           | x_1 = 1
# begin           | begin
#   local x = 0   |   x_2 = 0
# end             | end
#
# Simulating a function using a finite state machine (FSM) has a disadvantage
# that it cannot handle expressions, where identical left-hand sides (RHS)
# refer to different variables. This applies to both `let` as well as `local`
# constructions.
#
# We solve this problem by renaming all variables.
#
# We use a ScopeTracker type to keep track of the things that are already
# renamed. It is basically just a Vector{Dict{Symbol, Symbol}},
# representing a stack, where the top records the renamed variables in the
# current scope.
#
# The renaming is done as follows. If we encounter an assignment of the form
# x = y
# there are two cases for x:
#   1) x has been seen before in some scope. Then we replace x accordingly.
#   2) x has not been seen before. We give x a new name and store :x => :x_new
#      in current scope.
#
# This is done in lookup_lhs!. Note that some construction, like `let`, create
# a new variable in a new scope. This is handled by the `new` keyword.
#
# For any other symbol y (which is not the left hand side of an assignment),
# there are the following two cases:
#   1) y has been seen before in some scope. Then we replace y accordingly.
#   2) y has not been seen before, then we don't rename it.
#
# ---
#
# Note that we handle local x, by emitting a new variable :x => :x_new
# inside the current scope.
#
# We exploit this when rewriting let and for constructions, see below for
# examples with let. At the end, all `local x` are removed.

mutable struct ScopeTracker
  i::Int
  mod::Module
  scope_stack::Vector
end

function lookup_lhs!(s::Symbol, S::ScopeTracker; new::Bool = false)
  if !new
    for D in Iterators.reverse(S.scope_stack)
      if haskey(D, s)
        return D[s]
      end
    end
  end
  D = last(S.scope_stack)
  new_s = Symbol(s, Symbol("_$(S.i)"))
  S.i += 1
  D[s] = new_s
  return new_s
end

function lookup_lhs!(s::QuoteNode, S::ScopeTracker)
  return s
end

function lookup_lhs!(s::Expr, S::ScopeTracker; new = false)
  if s.head === :(.)
    s.args[1] = lookup_lhs!(s.args[1], S; new = new)
    return s
  end
  if s.head  === :tuple
    # we should never have to treat a (;a) = b here
    (s.args[1] isa Expr && s.args[1].head === :parameters) &&
        error("Illegal tuple expression in scope lookup: $(s.args[1])")

    # we should have an innocent (a, b, c) = ...
    for i in 1:length(s.args)
      s.args[i] = lookup_lhs!(s.args[i], S; new = new)
    end
    return s
  end
  if s.head === :ref
    s = scoping(s, S)
    return s
  end
  error("Not captured")
end

lookup_rhs!(e::typeof(ResumableFunctions.generate), scope) = e

function lookup_rhs!(s::Symbol, S::ScopeTracker)
  for D in Iterators.reverse(S.scope_stack)
    if haskey(D, s)
      return D[s]
    end
  end
  return s
end

scoping(e::LineNumberNode, scope) = e
scoping(e::Int, scope) = e
scoping(e::Float64, scope) = e
scoping(e::String, scope) = e
scoping(e::typeof(ResumableFunctions.generate), scope) = e
scoping(e::typeof(ResumableFunctions.IteratorReturn), scope) = e
scoping(e::QuoteNode, scope) = e
scoping(e::Bool, scope) = e
scoping(e::Nothing, scope) = e
scoping(e::GlobalRef, scope) = e

function scoping(s::Symbol, scope; new = false)
  return lookup_rhs!(s, scope)
end

const _logging_macros = (
  Symbol("@debug"),
  Symbol("@info"),
  Symbol("@warn"),
  Symbol("@error"),
  Symbol("@logmsg"),
)

function _is_logging_macro(name)
  name in _logging_macros
end

function _is_logging_macro(name::Expr)
  name.head === :. || return false
  macro_name = name.args[end]
  macro_name = macro_name isa QuoteNode ? macro_name.value : macro_name
  macro_name in _logging_macros
end

function _logging_macro_name(name)
  return name
end

function _logging_macro_name(name::Expr)
  macro_name = name.args[end]
  return macro_name isa QuoteNode ? macro_name.value : macro_name
end

function scope_logging_macro_arg(expr, scope; metadata = false)
  if expr isa Expr && expr.head === :(=)
    expr.args[2] = scoping(expr.args[2], scope)
    return expr
  end
  if metadata && expr isa Symbol
    return Expr(:(=), expr, scoping(expr, scope))
  end
  scoping(expr, scope)
end

function scope_generator_inner(expr, scope)
  for i in 2:length(expr.args)
    !(expr.args[i] isa Expr && expr.args[i].head === :(=)) &&
      error("Illegal expression in generator: $(expr.args[i])")
    expr.args[i].args[2] = scoping(expr.args[i].args[2], scope)
  end
  # now create new scope
  push!(scope.scope_stack, Dict())
  for i in 2:length(expr.args)
    expr.args[i].args[1] = lookup_lhs!(expr.args[i].args[1], scope, new = true)
  end
end

function scope_generator(expr, scope)
  expr.head !== :generator && error("Illegal generator expression: $(expr)")

  has_filter = length(expr.args) == 2 && expr.args[2] isa Expr && expr.args[2].head === :filter
  if has_filter
    ex = expr.args[2]
    scope_generator_inner(ex, scope)
    # now apply scoping to the filter condition expression
    ex.args[1] = scoping(ex.args[1], scope)
  else
    scope_generator_inner(expr, scope)
  end
  expr.args[1] = scoping(expr.args[1], scope)
  pop!(scope.scope_stack)
  return expr
end

function scoping(expr::Expr, scope)
  if expr.head === :generator
    return scope_generator(expr, scope)
  end

  # Named tuple handling is again pretty awkward
  # because of the (;a, b) syntax, which we have to expand by hand to
  # (;a = a, b = b), otherwise we do (;a_1, b_2), and this gets
  # (;a_1 = a_1, b_2 = b_2) which is nonsensical
  if expr.head === :tuple
    if length(expr.args) > 0 && expr.args[1] isa Expr && expr.args[1].head === :parameters
      # this is a named tuple of the form (;...)
      # TODO: named tuple recognition not working properly yet
      # first bring (;...,b,...) in the form (;...,b = b,...)
      for i in 1:length(expr.args[1].args)
        if !(expr.args[1].args[i] isa Expr)
          expr.args[1].args[i] = Expr(:kw, expr.args[1].args[i], expr.args[1].args[i])
        end
      end
      # Now rename the RHS
      for i in 1:length(expr.args[1].args)
        !(expr.args[1].args[i] isa Expr && expr.args[1].args[i].head === :kw) &&
          error("Illegal expression in named tuple: $(expr.args[1].args[i])")
        expr.args[1].args[i].args[2] = scoping(expr.args[1].args[i].args[2], scope)
      end
      return expr
    elseif any(a -> a isa Expr && a.head === :(=), expr.args[1:end])
      # Can be any of (a = 2, b, c = d)
      # lets first normalize the entries of the form b to b => scoping(b, ...)
      for i in 1:length(expr.args)
        if expr.args[i] isa Symbol
          expr.args[i] = Expr(:kw, expr.args[i], lookup_lhs!(expr.args[i], scope))
        else
          expr.args[i].head !== :(=) &&
            error("Unrecognized expression in tuple: $(expr.args[i])")
          expr.args[i].args[2] = scoping(expr.args[i].args[2], scope)
          expr.args[i].head = :kw
        end
      end
      # Let's normalize to a parameter (;...) form
      expr.args[1] = Expr(:parameters, expr.args...)
      expr.args = expr.args[1:1]
      return expr
    end
  end

  if expr.head === :call
    # Rename the caller name
    expr.args[1] = scoping(expr.args[1], scope)
    # We have to not rename the keyword arguments
    # Super awkward because of f(x, y = z, w) and f(x; y) is allowed :(
    # Or even f(x, y = 1, w, z = 2)
    for i in 2:length(expr.args)
      if expr.args[i] isa Expr && expr.args[i].head === :kw
        # this is f(..., x = 2, ...)
        expr.args[i].args[2] = scoping(expr.args[i].args[2], scope)
      elseif expr.args[i] isa Expr && expr.args[i].head === :parameters
        # this is f(...;...)
        # first normalize f(...;...,x...) to f(...;..., x = x,...)
        for j in 1:length(expr.args[i].args)
          if !(expr.args[i].args[j] isa Expr)
            expr.args[i].args[j] = Expr(:kw, expr.args[i].args[j], expr.args[i].args[j])
          end
        end
        for j in 1:length(expr.args[i].args)
          !(expr.args[i].args[j] isa Expr && expr.args[i].args[j].head === :kw) &&
            error("Unrecognized keyword expression: $(expr.args[i].args[j])")
          # this is f(...; x = 2)
          expr.args[i].args[j].args[2] = scoping(expr.args[i].args[j].args[2], scope)
        end
      else
        expr.args[i] = scoping(expr.args[i], scope)
      end
    end
    return expr
  end

  if expr.head === :(=)
    # One special case, where we need to have both LHS and RHS at our hands
    if expr.args[1] isa Expr && expr.args[1].head === :tuple && expr.args[1].args[1] isa Expr && expr.args[1].args[1].head === :parameters
      # OK, so this (;a, b) = c
      # lets transform this into
      # d = c # because c could be an expression itself
      # a_new = d.a
      # b_new = d.b
      d = gensym()
      res = [quote $(d) = $(expr.args[2]); end]
      for i in 1:length(expr.args[1].args[1].args)
        lhs = expr.args[1].args[1].args[i]
        !(lhs isa Symbol) &&
          error("Unrecognized expression in named tuple assignment: $(lhs)")
        lhslookup = lookup_lhs!(lhs, scope)
        push!(res, quote $(lhslookup) = $(d).$(lhs) end)
      end
      return quote $(res...) end
    end

    # first transform the RHS (this can be anything) to check for shadowing of globals
    for i in 2:length(expr.args)
      expr.args[i] = scoping(expr.args[i], scope)
    end

    # only then deal with the LHS (it is a symbol or a tuple of symbols)
    expr.args[1] = lookup_lhs!(expr.args[1], scope)

    return expr
  end
  if expr.head === :macrocall
    if _is_logging_macro(expr.args[1])
      metadata_start = _logging_macro_name(expr.args[1]) === Symbol("@logmsg") ? 5 : 4
      for i in 2:length(expr.args)
        expr.args[i] = scope_logging_macro_arg(
          expr.args[i], scope; metadata = i >= metadata_start
        )
      end
      return expr
    end
    for i in 2:length(expr.args)
      expr.args[i] = scoping(expr.args[i], scope)
    end
    return expr
  end
  if expr.head === :let
    # Replace
    #   let i, k = 2, j = 1
    #      [...]
    #   end
    #
    #   by
    #
    #   let
    #     local i_new
    #     local k_new = 2
    #     local j_new = 1
    #   end
    #
    #   Caveat:
    #   let i = i, j = i
    #
    #   must be
    #   new_i = old_i
    #   new_j = new_i
    #
    #   Thus we add a new scope, resolve the RHS and force the LHS to be new.
    #   Do this one after the other and everything will be fine.

    @capture(expr, let arg_; body_ end) || return expr
    @capture(arg, begin x__ end)
    push!(scope.scope_stack, Dict())
    rep = []
    for i in 1:length(x)
      y = x[i]
      fl = @capture(y, k_ = v_)
      if fl
        replace_rhs = scoping(v, scope)
        replace_lhs = lookup_lhs!(k, scope, new = true)
        push!(rep, quote local $(replace_lhs); $(replace_lhs) = $(replace_rhs) end)
      else
        !(y isa Symbol) &&
          error("Unrecognized expression in let expression: $(y)")
        replace_lhs = lookup_lhs!(y, scope, new = true)
        push!(rep, quote local $(replace_lhs) end)
      end
    end
    rep = quote
      $(rep...)
    end
    rep = flatten(rep)
    expr.args[1] = Expr(:block)
    pushfirst!(expr.args[2].args, rep)

    # Now continue recursively
    # but skip the local/dance, since we already replaced them
    for i in 2:length(expr.args[2].args)
      a = expr.args[2].args[i]
      expr.args[2].args[i] = scoping(a, scope)
    end
    pop!(scope.scope_stack)
    return expr
  end

  new_stack = false
  if expr.head === :while
    push!(scope.scope_stack, Dict())
    new_stack = true
  end

  if expr.head === :local
    # if we see a local x or local x = ...
    # we always emit a new identifier
    if length(expr.args) == 1 && expr.args[1] isa Symbol
      expr.args[1] = lookup_lhs!(expr.args[1], scope)
    elseif length(expr.args) == 1 && expr.args[1].head === :tuple
      for i in 1:length(expr.args[1].args)
        a = expr.args[1].args[i]
        expr.args[1].args[i] = lookup_lhs!(a, scope)
      end
    else
      # this is local x = y
      !(length(expr.args) == 1 && expr.args[1] isa Expr && expr.args[1].head === :(=)) &&
        error("Illegal local expression: $(expr.args)")
      expr.args[1].args[1] = lookup_lhs!(expr.args[1].args[1], scope)
      expr.args[1].args[2] = scoping(expr.args[1].args[2], scope)
      expr = quote local $(expr.args[1].args[1]); $(expr.args[1].args[1]) = $(expr.args[1].args[2]); end
    end
    return expr
  end

  # default
  for i in 1:length(expr.args)
    a = expr.args[i]
    expr.args[i] = scoping(a, scope)
  end

  if new_stack
    pop!(scope.scope_stack)
  end
  return expr
end

using Test
using ResumableFunctions

@resumable function test_yieldfrom_inner(n)
  for i in 1:n
    @yield i^2
  end
  42, n
end

@resumable function test_yieldfrom(n)
  @yieldfrom [42, 314]   
  m, n = @yieldfrom test_yieldfrom_inner(n)
  @test m == 42
  @yield n
  @yieldfrom test_yieldfrom_inner(n+1)
end

@testset "test_yieldfrom" begin
@test collect(test_yieldfrom(4)) == [42, 314, 1, 4, 9, 16, 4, 1, 4, 9, 16, 25]
end

@resumable function test_echo()
  x = 0
  while true
    x = @yield x
  end
  return "Done"
end

@resumable function test_forward()
  ret = @yieldfrom test_echo()
  @test ret == "Done"
  @yieldfrom test_echo()
end

@testset "test_yieldfrom_twoway" begin
  forward = test_forward()
  @test forward() == 0
  for i in 1:5
    @test forward(i) == i
  end
end

@testset "test_yieldfrom_nonresumable" begin
  @test_throws LoadError eval(:(@yieldfrom [1,2,3]))
end


@testset "test_yieldfrom_noargs" begin
  test_f = :(@resumable function test_yieldfrom_noargs()
    @yieldfrom
  end)
  @test_throws LoadError eval(test_f)
end

using ResumableFunctions
using Test

@resumable function test_type_parameters(::Type{Int}, start::Int)
  for i in start:start+3
    @yield i
  end
end

@resumable function test_type_parameters(::Type{Float64}, start::Int)
  for i in start:start+3
    @yield float(i)
  end
end

@testset "test_type_parameters" begin
  @test collect(test_type_parameters(Int, 1)) == [1, 2, 3, 4]
  @test collect(test_type_parameters(Float64, 1)) == [1.0, 2.0, 3.0, 4.0]
end

@resumable function test_type_parameters_order(start::Int, ::Type{T})::T where {T}
  for i in start:start+3
    @yield T(i)
  end
end

@testset "test_type_parameters_order" begin
  @test collect(test_type_parameters_order(1, Int)) == [1, 2, 3, 4]
  @test collect(test_type_parameters_order(1, Float64)) == [1.0, 2.0, 3.0, 4.0]
  @test typeof(first(test_type_parameters_order(1, ComplexF32))) == ComplexF32
end

@resumable function test_type_parameters_optional(start::Int; t::Type{T}=Type{Int})::T where {T}
  for i in start:start+3
    @yield T(i)
  end
end


@testset "test_type_parameters_optional" begin
  @test collect(test_type_parameters_optional(1, t=Int)) == [1, 2, 3, 4]
  @test collect(test_type_parameters_optional(1, t=Float64)) == [1.0, 2.0, 3.0, 4.0]
  @test typeof(first(test_type_parameters_optional(1, t=ComplexF32))) == ComplexF32
end

using ResumableFunctions
using Test

a = 1
g() = 1
h(x) = x+1

@resumable function f1()
    b = a
    b = b+1
    @yield b
end

@test collect(f1()) == [2]

@resumable function f2()
    a = a
    a = a+1
    @yield a
end

@test collect(f2()) == [2]

@resumable function f3()
    g = g()
    g = g+1
    @yield g
end

@test collect(f3()) == [2]

@resumable function f4()
    a = h(a)
    a = a+1
    @yield a
end

@test collect(f4()) == [3]

@resumable function f5()
    g = h(g())
    g = g+1
    @yield g
end

@test collect(f5()) == [3]

using BenchmarkTools
using Pkg
using StableRNGs
using ResumableFunctions

const SUITE = BenchmarkGroup()

const rng = StableRNG(42)

const n = 93

Manifest = Pkg.Operations.Context().env.manifest
V = Manifest[findfirst(v -> v.name == "ResumableFunctions", Manifest)].version


## Benchmarks hardcoded for various types
const hardcoded_types = [Int, BigInt]

S_hc = SUITE["hardcoded types"] = BenchmarkGroup(["hardcoded types"])

for N in hardcoded_types # define a separate submodule for each hardcoded type
@eval module $(Symbol("Test", N))

using BenchmarkTools
using ResumableFunctions
using ..Main: S_hc, rng, V

const n = $n
const N = $N
str = string(N)
S = S_hc[str] = BenchmarkGroup([str])

# the functions to be benchmarked

function direct(a::N, b::N)
  b, a+b
end

function test_direct(n::Int)
  a, b = zero(N), one(N)
  for _ in 1:n-1
    a, b = direct(a, b)
  end
  a
end

@resumable function fibonacci_resumable(n::Int)
  a, b = zero(N), one(N)
  for _ in 1:n
    @yield a
    a, b = b, a + b
  end
end

@noinline function test_resumable(n::Int)
  a = 0
  for v in fibonacci_resumable(n)
    a = v
  end
  a
end

function fibonacci_channel(n::Int, ch::Channel)
  a, b = zero(N), one(N)
  for _ in 1:n
    put!(ch, a)
    a, b = b, a + b
  end
end

@noinline function test_channel(n::Int, csize::Int)
  fib_channel = Channel(c -> fibonacci_channel(n, c); ctype=N, csize=csize)
  a = 0
  for v in fib_channel
    a = v
  end
  a
end

struct Generator
  callee :: Task
  function Generator(f::Function, args...; kwargs...)
      ct = current_task()
      new(@task begin task_local_storage(:caller, ct); f(args...; kwargs...); yield(ct) end)
  end
end

function Base.iterate(gen::Generator, state=nothing)
  ret = yieldto(gen.callee)
  if ret === nothing return nothing end
  ret, nothing
end

function consume(gen::Generator, val=nothing)
  yieldto(gen.callee, val)
end


function produce(val=nothing)
  t = task_local_storage(:caller)
  yieldto(t, val)
end

function fibonacci_task(n::Int)
  a,b = zero(N), one(N)
  for _ in 1:n
      produce(a)
      a, b = b, a+b
  end
end

@noinline function test_task(n::Int)
  a = 0
  for v in Generator(fibonacci_task, n)
    a = v
  end
  a
end

function fibonacci_closure()
  a, b = zero(N), one(N)
  function()
    tmp = a
    a, b = b, a + b
    tmp
  end
end

@noinline function test_closure(n::Int)
  fib_closure = fibonacci_closure()
  a = 0
  for _ in 1:n
    a = fib_closure()
  end
  a
end

function fibonacci_closure_opt()
  a = Ref(zero(N))
  b = Ref(one(N))
  function()
    tmp = a[]
    a[], b[] = b[], a[] + b[]
    tmp
  end
end

@noinline function test_closure_opt(n::Int)
  fib_closure = fibonacci_closure_opt()
  a = 0
  for _ in 1:n
    a = fib_closure()
  end
  a
end

function fibonacci_closure_stm(n::Int)
  _state = Ref(0x00)
  a = Ref{N}()
  b = Ref{N}()
  _iterstate_1 = Ref{Int}()
  _iterator_1 = Ref{UnitRange{Int}}()

  function(_arg::Any=nothing)
    _state[] === 0x00 && @goto _STATE_0
    _state[] === 0x01 && @goto _STATE_1
    error("@resumable function has stopped!")
    @label _STATE_0
    _state[] = 0xff
    _arg isa Exception && throw(_arg)
    a[], b[] = zero(Int), one(Int)
    _iterator_1[] = 1:n
    _iteratornext_1 = iterate(_iterator_1[])
    while _iteratornext_1 !== nothing
      (_, _iterstate_1[]) = _iteratornext_1
      _state[] = 0x01
      return a[]
      @label _STATE_1
      _state[] = 0xff
      _arg isa Exception && throw(_arg)
      (a[], b[]) = (b[], a[] + b[])
      _iteratornext_1 = iterate(_iterator_1[], _iterstate_1[])
    end
  end
end

const FibClosure = typeof(fibonacci_closure_stm(n))

function Base.iterate(f::FibClosure, state=nothing)
  a = f()
  f._state[] === 0xff && return nothing
  a, nothing
end

@noinline function test_closure_stm(n::Int)
  fib_closure = fibonacci_closure_stm(n)
  a = 0
  for v in fibonacci_closure_stm(n)
    a = v
  end
  a
end

struct FibN
  n::Int
end

function Base.iterate(f::FibN, state::Tuple{N, N, Int}=(zero(N), one(N), 1))
  a, b, iters = state
  iters > f.n && return nothing
  a, (b, a + b, iters + 1)
end

@noinline function test_iteration_protocol(n::Int)
  a = 0
  for v in FibN(n)
    a = v
  end
  a
end


# define the benchmarks
S["Direct"] = @benchmarkable test_direct(_n) setup=(_n=n)
S["ResumableFunctions"] = @benchmarkable test_resumable(_n) setup=(_n=n)
S["Channels csize=0"] = @benchmarkable test_channel(_n, 0) setup=(_n=n)
S["Channels csize=1"] = @benchmarkable test_channel(_n, 1) setup=(_n=n)
S["Channels csize=20"] = @benchmarkable test_channel(_n, 20) setup=(_n=n)
S["Channels csize=100"] = @benchmarkable test_channel(_n, 100) setup=(_n=n)
S["Task scheduling"] = @benchmarkable test_task(_n) setup=(_n=n)
S["Closure"] = @benchmarkable test_closure(_n) setup=(_n=n)
S["Closure optimized"] = @benchmarkable test_closure_opt(_n) setup=(_n=n)
S["Closure statemachine"] = @benchmarkable test_closure_stm(_n) setup=(_n=n)
S["Iteration protocol"] = @benchmarkable test_iteration_protocol(_n) setup=(_n=n)

end # module
end # for N in [Int, BigInt]


##

# run as `julia --project=. benchmark/benchmarks.jl`
const T = Int # pick a type to test for (from hardcoded_types)

isinteractive() || get(ENV,"CI","false") =="true" || begin
  println("\n\nTesting with $T\n")
  eval( :(import .$(Symbol("Test",T)): test_direct, test_resumable, test_channel, test_task, test_closure, test_closure_opt, test_closure_stm, test_iteration_protocol) )
  println("Direct: ")
  @btime test_direct($n)
  @assert test_direct(n) == 7540113804746346429

  println("ResumableFunctions: ")
  @btime test_resumable($n)
  @assert test_resumable(n) == 7540113804746346429

  println("Channels csize=0: ")
  @btime test_channel($n, $0)
  @assert test_channel(n, 0) == 7540113804746346429

  println("Channels csize=1: ")
  @btime test_channel($n, $1)
  @assert test_channel(n, 1) == 7540113804746346429

  println("Channels csize=20: ")
  @btime test_channel($n, $20)
  @assert test_channel(n, 20) == 7540113804746346429

  println("Channels csize=100: ")
  @btime test_channel($n, $100)
  @assert test_channel(n, 100) == 7540113804746346429

  println("Task scheduling")
  @btime test_task($n)
  @assert test_task(n) == 7540113804746346429

  println("Closure: ")
  @btime test_closure($n)
  @assert test_closure(n) == 7540113804746346429

  println("Closure optimised: ")
  @btime test_closure_opt($n)
  @assert test_closure_opt(n) == 7540113804746346429

  println("Closure statemachine: ")
  @btime test_closure_stm($n)
  @assert test_closure_stm(n) == 7540113804746346429

  println("Iteration protocol: ")
  @btime test_iteration_protocol($n)
  @assert test_iteration_protocol(n) == 7540113804746346429
end

"""
Function that removes `local x` expression.
"""
function transform_remove_local(ex)
  ex isa Expr && ex.head === :local && return Expr(:block)
  return ex
end

"""
Function that replaces a variable
"""
function transform_nosave(expr, nosaves::Set{Symbol})
  @capture(expr, @nosave var_ = body_) || return expr
  push!(nosaves, var)
  :($var = $body)
end

"""
Function that replaces a `@yieldfrom iter` statement with
```julia
  _other_ = iter...
  _ret_ = generate(_other_, nothing)
  while !(_ret_ isa IteratorReturn)
    _value_, _state_ = _ret_
    _newvalue_ = @yield _value_
    _ret_ = generate(_other_, _newvalue_, _state_)
  end
  _
```
"""
function transform_yieldfrom(expr)
  _is_yieldfrom(expr) || return expr
  iter = expr.args[3:end]
  quote
    _other_ = $(iter...)
    _ret_ = $generate(_other_, nothing)
    while !(_ret_ isa $IteratorReturn)
      _value_, _state_ = _ret_
      _newvalue_ = @yield _value_
      _ret_ = $generate(_other_, _newvalue_, _state_)
    end
  end
end

"""
Function that replaces an `arg = @yieldfrom iter` statement by
```julia
  @yieldfrom iter
  arg = _ret_.value
```
"""
function transform_arg_yieldfrom(expr)
  @capture(expr, arg_ = ex_) || return expr
  _is_yieldfrom(ex) || return expr
  iter = ex.args[3:end]
  quote
    @yieldfrom $(iter...)
    $arg = _ret_.value
  end
end

"""
Function returning whether an expression is a `@yieldfrom` macro
"""
_is_yieldfrom(ex) = false

function _is_yieldfrom(ex::Expr)
  is_ = ex.head === :macrocall && ex.args[1] === Symbol("@yieldfrom")
  if is_ && length(ex.args) < 3
    error("@yieldfrom without arguments!")
  end
  return is_
end


"""
Function that replaces a `for` loop by a corresponding `while` loop saving explicitly the *iterator* and its *state*.

For loops of the form `for a, b, c; body; end` are denested.
"""
function transform_for(expr, ui8::BoxedUInt8)
  (expr isa Expr && expr.head === :for) || return expr
  # test for simple for a in b expression
  expr.args[1].head === :(=) && return transform_for_inner(expr, ui8)
  # must be a complicated iteration
  expr.args[1].head !== :block && error("Unrecognized for expression: $(expr.args[1])")
  body = expr.args[2]
  # denest, starting at the back
  for a in reverse(expr.args[1].args)
    body = Expr(:for, a, body)
    # turn for into while loop
    body = transform_for_inner(body, ui8)
  end
  return body
end

function transform_for_inner(expr, ui8::BoxedUInt8)
  # turning for into while loops
  @capture(expr, for element_ in iterator_ body_ end) || return expr
  localelement = Expr(:local, element)
  ui8.n += one(UInt8)
  next = Symbol("_iteratornext_", ui8.n)
  state = Symbol("_iterstate_", ui8.n)
  iterator_value = Symbol("_iterator_", ui8.n)
  label = Symbol("_iteratorlabel_", ui8.n)
  body = postwalk(x->transform_continue(x, label), :(begin $(body) end))
  res = quote
    $iterator_value = $iterator
    @nosave $next = iterate($iterator_value)
    while $next !== nothing
      $localelement
      ($element, $state) = $next
      $body
      @label $label
      $next = iterate($iterator_value, $state)
    end
  end
  res
end


"""
Function that replaces a `continue` statement by a corresponding `@goto` with as label the correct location for the next iteration.
"""
function transform_continue(expr, label::Symbol)
  @capture(expr, continue) || return expr
  :(@goto $label)
end

"""
Function that replaces a variable `x` in an expression by `_fsmi.x` where `x` is a known slot.
"""
function transform_slots(expr, symbols)
  expr isa Expr || return expr
  #expr.head === :let && return transform_slots_let(expr, symbols)

  # "Problematic" expressions all have been transformed into Expr(:kw,...)
  for i in 1:length(expr.args)
    expr.head === :kw && i === 1 && continue
    expr.head === Symbol("quote") && continue
    expr.args[i] = expr.args[i] isa Symbol && expr.args[i] in symbols ? :(_fsmi.$(expr.args[i])) : expr.args[i]
  end
  expr
end

"""
Function that replaces a `arg = @yield ret` statement by
```julia
  @yield ret;
  arg = arg_
```
where `arg_` is the argument of the function containing the expression.
"""
function transform_arg(expr)
  @capture(expr, arg_ = ex_) || return expr
  _is_yield(ex) || return expr
  ret = length(ex.args) > 2 ? ex.args[3:end] : [nothing]
  quote
    @yield $(ret...)
    $arg = _arg
  end
end

"""
Function that replaces a `@yield ret` or `@yield` statement by
```julia
  @yield ret
  _arg isa Exception && throw(_arg)
```
to allow that an `Exception` can be thrown into a `@resumable function`.
"""
function transform_exc(expr)
  _is_yield(expr) || return expr
  ret = length(expr.args) > 2 ? expr.args[3:end] : [nothing]
  quote
    @yield $(ret...)
    _arg isa Exception && throw(_arg)
  end
end

"""
Function that replaces a `try`-`catch`-`finally`-`end` expression having a top level `@yield` statement in the `try` part
```julia
  try
    before_statements...
    @yield ret
    after_statements...
  catch exc
    catch_statements...
  finally
    finally_statements...
  end
```
with a sequence of `try`-`catch`-`end` expressions:
```julia
  try
    before_statements...
  catch
    catch_statements...
    @goto _TRY_n
  end
  @yield ret
  try
    after_statements...
  catch
    catch_statements...
  end
  @label _TRY_n
  finally_statements...
```
"""
function transform_try(expr, ui8::BoxedUInt8)
  @capture(expr, (try body_ catch exc_; handling_ end) | (try body_ catch exc_; handling_ finally always_ end)) || return expr
  ui8.n += one(UInt8)
  new_body = []
  segment = []
  for ex in body.args
    if _is_yield(ex)
      ret = length(ex.args) > 2 ? ex.args[3:end] : [nothing]
      exc === nothing ? push!(new_body, :(try $(segment...) catch; $(handling); @goto $(Symbol("_TRY_", :($(ui8.n)))) end)) : push!(new_body, :(try $(segment...) catch $exc; $(handling) ; @goto $(Symbol("_TRY_", :($(ui8.n)))) end))
      push!(new_body, quote @yield $(ret...) end)
      segment = []
    else
      push!(segment, ex)
    end
  end
  if segment != []
    exc === nothing ? push!(new_body, :(try $(segment...) catch; $(handling) end)) : push!(new_body, :(try $(segment...) catch $exc; $(handling) end))
  end
  push!(new_body, :(@label $(Symbol("_TRY_", :($(ui8.n))))))
  always === nothing || push!(new_body, quote $(always) end)
  quote $(new_body...) end
end

"""
Function that replaces a `@yield ret` or `@yield` statement with
```julia
  _fsmi._state = n
  return ret
  @label _STATE_n
  _fsmi._state = 0xff
```
"""
function transform_yield(expr, ui8::BoxedUInt8)
  _is_yield(expr) || return expr
  ret = length(expr.args) > 2 ? expr.args[3:end] : [nothing]
  ui8.n += one(UInt8)
  quote
    _fsmi._state = $(ui8.n)
    return $(ret...)
    @label $(Symbol("_STATE_", :($(ui8.n))))
    _fsmi._state = 0xff
  end
end

"""
Function that replaces a `@yield ret` or `@yield` statement with
```julia
  Base.inferencebarrier(ret)
```
This version is used for inference only.
It makes sure that `val = @yield ret` is inferred as `Any` rather than `typeof(ret)`.
"""
function transform_yield(expr)
  _is_yield(expr) || return expr
  ret = length(expr.args) > 2 ? expr.args[3:end] : [nothing]
  quote
    Base.inferencebarrier($(ret...))
  end
end

"""
Function returning whether an expression is a `@yield` macro
"""
_is_yield(ex) = false

function _is_yield(ex::Expr)
  ex.head === :macrocall && ex.args[1] === Symbol("@yield")
end

using ResumableFunctions
using Test
using SafeTestsets
using REPL # work around regression with @doc macro: https://github.com/JuliaLang/julia/issues/54664

function doset(descr)
    if length(ARGS) == 0
        return true
    end
    for a in ARGS
        if occursin(lowercase(a), lowercase(descr))
            return true
        end
    end
    return false
end

macro doset(descr)
    quote
#        @info "====================================="
#        @info $descr
        if doset($descr)
            @safetestset $descr begin
                include("test_"*$descr*".jl")
            end
        end
    end
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@doset "main"
@doset "yieldfrom"
@doset "typeparams"
@doset "repeated_variable"
@doset "inference_recursive_calls"
@doset "selfreferencing_functional"
@doset "coverage_preservation"
@doset "performance"
@doset "logging"
VERSION >= v"1.8" && @doset "doctests"
VERSION >= v"1.8" && @doset "aqua"
isempty(VERSION.prerelease) && VERSION >= v"1.12" && @doset "jet"
@doset "explicitimports"

using ResumableFunctions
using JET
using Test

@testset "JET checks" begin
    rep = report_package("ResumableFunctions";
        ignored_modules=(
            Core.Compiler,
        )
    )
    @show rep
    @test length(JET.get_reports(rep)) <= 8
    @test_broken length(JET.get_reports(rep)) == 0
end

using ResumableFunctions
using Test
using MacroTools: postwalk

before = :(function f(arg, arg2::Int)
        @yield arg
        for i in 1:10
            let i=i
                @yield arg2
                arg2 = arg2 + i
            end
        end
        while true
            try
                @yield arg2
                arg2 = arg2 + 1
            catch e
                @yield e
                arg2 = arg2 + 1
            end
            break
        end
        arg2+arg
        @yield arg2
    end
)

after = eval(quote @macroexpand @resumable $before end)

function get_all_linenodes(expr)
    nodes = Set()
    postwalk(expr) do x
        if x isa LineNumberNode
            push!(nodes, x)
        end
        x
    end
    return nodes
end

@testset "all line numbers are preserved" begin
@test get_all_linenodes(before) ⊆ get_all_linenodes(after)
end

using Logging
using ResumableFunctions
using Test

mutable struct CaptureLogger <: AbstractLogger
  records::Vector{NamedTuple}
end

Logging.min_enabled_level(::CaptureLogger) = Logging.Debug
Logging.shouldlog(::CaptureLogger, _level, _module, _group, _id) = true
Logging.catch_exceptions(::CaptureLogger) = false

function Logging.handle_message(
  logger::CaptureLogger,
  level,
  message,
  _module,
  group,
  id,
  file,
  line;
  kwargs...,
)
  push!(logger.records, (; level, message, group, metadata=(; kwargs...)))
end

@resumable function logging_generator()
  round = 3
  pair_id = 7
  attempts = 2
  @debug(
    "Logging from a resumable function",
    _group=:protocol,
    event=:round_started,
    round=round,
    pair_id,
    attempts,
  )
  @yield round
end

@resumable function qualified_logging_generator()
  value = 4
  Logging.@info(
    "Qualified logging macro",
    _group=:qualified,
    event=:qualified_record,
    value,
  )
  @logmsg(
    Logging.Warn,
    "Logging with an explicit level",
    _group=:logmsg,
    event=:logmsg_record,
    value,
  )
  @yield value
end

@testset "structured logging metadata" begin
  logger = CaptureLogger(NamedTuple[])
  values = Logging.with_logger(logger) do
    collect(logging_generator())
  end

  @test values == [3]
  @test length(logger.records) == 1
  record = only(logger.records)
  @test record.level == Logging.Debug
  @test record.message == "Logging from a resumable function"
  @test record.group == :protocol
  @test record.metadata == (
    event=:round_started,
    round=3,
    pair_id=7,
    attempts=2,
  )

  empty!(logger.records)
  values = Logging.with_logger(logger) do
    collect(qualified_logging_generator())
  end

  @test values == [4]
  @test length(logger.records) == 2
  qualified_record, logmsg_record = logger.records
  @test qualified_record.level == Logging.Info
  @test qualified_record.group == :qualified
  @test qualified_record.metadata == (event=:qualified_record, value=4)
  @test logmsg_record.level == Logging.Warn
  @test logmsg_record.group == :logmsg
  @test logmsg_record.metadata == (event=:logmsg_record, value=4)
end

using Documenter
using AnythingLLMDocs
using ResumableFunctions

doc_modules = [ResumableFunctions]

api_base="https://anythingllm.krastanov.org/api/v1"
anythingllm_assets = integrate_anythingllm(
  "ResumableFunctions",
  doc_modules,
  @__DIR__,
  api_base;
  repo = "github.com/JuliaDynamics/ResumableFunctions.jl",
  options = EmbedOptions(),
)

makedocs(
  sitename = "ResumableFunctions",
  authors = "Ben Lauwens and volunteers from JuliaDynamics and QuantumSavory",
  format = Documenter.HTML(assets = anythingllm_assets),
  modules = doc_modules,
  pages = [
    "Home" => "index.md",
    "Manual" => "manual.md",
    "Internals" => "internals.md",
    "Library" => "library.md"
  ]
)

deploydocs(
  repo = "github.com/JuliaDynamics/ResumableFunctions.jl"
)

using ResumableFunctions
using Test

@resumable function test_for(a::Int=0; b::Int=a+1) :: Int
  for i in 1:10
    @yield a
    a, b = b, a+b
  end
end

@testset "test_for" begin
@test collect(test_for(4)) == [4, 5, 9, 14, 23, 37, 60, 97, 157, 254]
end

@resumable function test_try(io)
  try
    a = 1
    @yield a
    a = 2
    c = @yield a
    println(io,c)
  catch except
    println(io,except)
  finally
    println(io,"Always")
  end
end

struct SpecialException <: Exception end
@testset "test_try" begin
io = IOBuffer()
try_me = test_try(io)
try_me()
try_me(SpecialException())
@test endswith(String(take!(copy(io))), "SpecialException()\nAlways\n")

io = IOBuffer()
try_me = test_try(io)
try_me()
try_me()
try_me("Hello")
@test String(take!(copy(io))) == "Hello\nAlways\n"

io = IOBuffer()
try_me = test_try(io)
try_me()
try_me()
try_me(SpecialException())
@test_throws ErrorException try_me()
@test endswith(String(take!(copy(io))), "SpecialException()\nAlways\n")
end

@resumable function (test_where1(a::N) :: N) where {N<:Number}
  b = a + one(N)
  for i in 1:10
    @yield a
    a, b = b, a+b
  end
end

@resumable function (test_where2(a::N=4; b::N=a + one(N)) :: N) where N
  for i in 1:10
    @yield a
    a, b = b, a+b
  end
end

@testset "test_where" begin
@test collect(test_where1(4.0)) == [4.0, 5.0, 9.0, 14.0, 23.0, 37.0, 60.0, 97.0, 157.0, 254.0]
@test collect(test_where2(4)) == [4, 5, 9, 14, 23, 37, 60, 97, 157, 254]
end

@resumable function test_varargs(a...)
  for (i, e) in enumerate(a)
    @yield e
  end
end

@testset "test_varargs" begin
@test collect(test_varargs(1, 2, 3)) == [1, 2, 3]
end

@testset "test_let" begin
  @resumable function test_let()
    for u in [[(1,2),(3,4)], [(5,6),(7,8)]]
      for i in 1:2
        local val
        let i=i
          val = [a[i] for a in u]
        end
        @yield val
      end
    end
  end
  @test collect(test_let()) == [[1,3],[2,4],[5,7],[6,8]]

  @resumable function test_let2()
    a = 3
    b = 2
    let a = b, b = a, c = b
      @yield a, b, c
    end
    @yield a, b
  end
  @test collect(test_let2()) == [(2, 2, 2), (3, 2)]

  @resumable function test_let3()
    a = 3
    b = 2
    let a = a, b = a, c = b
      @yield a, b, c
    end
    @yield a, b
  end
  @test collect(test_let3()) == [(3, 3, 3), (3, 2)]
end

if VERSION >= v"1.8"

@resumable function test_let2()
  for u in [[(1,2),(3,4)], [(5,6),(7,8)]]
    for i in 1:2
      local val
      let i=i, j=i
        val = [(a[i],a[j]) for a in u]
      end
      @yield val
    end
  end
end

@testset "test_let2" begin
@test collect(test_let2()) == [[(1, 1), (3, 3)], [(2, 2), (4, 4)], [(5, 5), (7, 7)], [(6, 6), (8, 8)]]
end

@resumable function test_let_noassignment()
  for u in [[(1,2),(3,4)], [(5,6),(7,8)]]
    for i in 1:2
      local val
      let i
        val = [a[1] for a in u]
      end
      @yield val
    end
  end
end

@testset "test_let_noassignment" begin
collect(test_let_noassignment()) == [[1, 3], [1, 3], [5, 7], [5, 7]]
end

@resumable function test_let_multipleargs()
  for u in [[(1,2),(3,4)], [(5,6),(7,8)]]
    for i in 1:2
      local val
      let i=i, j
        val = [a[i] for a in u]
      end
      @yield val
    end
  end
end

@testset "test_let_multipleargs" begin
@test collect(test_let_multipleargs()) == [[1, 3], [2, 4], [5, 7], [6, 8]]
end

end # VERSION >= v"1.8"

@resumable function test_nosave()
  for i in 65:74
    @nosave tmp = Char(i)
    @yield tmp
  end
end

@testset "test_nosave" begin
@test collect(test_nosave()) == ['A', 'B', 'C', 'D', 'E',  'F', 'G', 'H', 'I', 'J']
end

@resumable function test_return_value()
  return 1
end

@testset "test_return_value" begin
  @test collect(test_return_value()) == []
end

@resumable function test_continue()
  for i in 1:10
    if i === 2
      continue
    end
    @yield i
  end
end

@resumable function test_continue_double()
  for i in 1:3
    if i === 2
      continue
    end
    for j in 1:3
      if j === 2
        continue
      end
      @yield j
    end
  end
end

@testset "test_continue" begin
  @test collect(test_continue()) == [1, 3, 4, 5, 6, 7, 8, 9, 10]
  @test collect(test_continue_double()) == [1, 3, 1, 3]
end

"""docstring"""
@resumable function fwithdoc()
    @yield 1
end

"""docstring"""
function gwithdoc()
    return 1
end

@testset "test_docstring" begin
@test (@doc fwithdoc) == (@doc gwithdoc)
end

@resumable function test_unstable(a::Int)
  for i in 1:a
    a = "number $i"
    @yield a
  end
end

@testset "test_unstable" begin
  @test collect(test_unstable(3)) == ["number 1", "number 2", "number 3"]
end

@testset "test_scope" begin
@resumable function test_scope_throws()
  for u in [[(1,2),(3,4)], [(5,6),(7,8)]]
    for i in 1:2
      let i=i, j
        val = [a[i] for a in u]
      end
      @yield val
    end
  end
end
@test_throws UndefVarError collect(test_scope_throws())

# test length

@testset "test_length" begin
  @resumable length=n^2*m^2 function test_length(n, m)
    for i in 1:n^2
      for j in 1:m^2
        @yield i + j
      end
    end
  end

  @test length(test_length(10, 20)) === 10^2 * 20^2
  @test length(collect(test_length(10, 20))) === 10^2 * 20^2
  @test Base.IteratorSize(typeof(test_length(1, 1))) == Base.HasLength()
end

@testset "test_scope_2" begin
  @resumable function test_forward()
    for i in 1:10
      @yield test_bla(i)
    end
  end

  test_bla(i) = i^2

  @test collect(test_forward()) == [i^2 for i in 1:10]
end

@testset "test_kw" begin
  g(x, y; z = 2) = x + y^2 + z

  @resumable function test_kw(z)
    y = 1
    @yield g(z, z = y, 2)
  end

  @test collect(test_kw(3)) == [8]

  g(z; y) = z - y

  @resumable function test_kw_2(x)
    for y in 1:10
      @yield g(x; y)
    end
  end

  @test collect(test_kw_2(2)) == [1, 0, -1, -2, -3, -4, -5, -6, -7, -8]
end

@testset "test_call_renaming" begin
  g(x) = x^2

  @resumable function test_call_renaming(y)
    sin = g
    let g = 3
      for h in 1:10
        @yield sin(g + h + y)
      end
    end
  end

  @test collect(test_call_renaming(3)) == [49, 64, 81, 100, 121, 144, 169, 196, 225, 256]
end

@testset "test_quotenode" begin
  @resumable function test_quotenode(x)
    @yield x.a^2 + x.b^2
  end

  @test collect((test_quotenode((a = 3, b = 4)))) == [5^2]
end

@testset "test_named_tuple" begin
  @resumable function test_named_tuple(u, v)
    r = @NamedTuple{a::Int, b::Int}[]
    for a in u
      for b in v
        push!(r, (;a, b))
        @yield (;a, b)
      end
    end
    @yield r[2]
  end

  @test collect(test_named_tuple([1, 2], [3, 4])) == [(a = 1, b = 3), (a = 1, b = 4), (a = 2, b = 3), (a = 2, b = 4), (a = 1, b = 4)]

  @resumable function test_32()
    x = 0
    @yield (x = 1, )
  end

  @test collect(test_32()) == [(x = 1, )]

  @resumable function test_named_tuple2(b)
    @yield (;a = b.a + 2, b)
  end
  @test collect(test_named_tuple2((a = 1, ))) == [(a = 3, b = (a = 1,))]

  @resumable function test_named_tuple3(b)
    @yield (a = b.a + 2, b)
  end
  @test collect(test_named_tuple3((a = 1, ))) == [(a = 3, b = (a = 1,))]

end

@testset "test_comprehension" begin
  @resumable function test_comprehension(u)
    r = Dict{Int, Int}(c =>i for (i, c) in u)
    s = [u^2 for u in first.(u)]
    for k in sort(collect(keys(r)))
      @yield k
    end
    for s in s
      @yield s
    end
  end
  @test collect(test_comprehension([(1, 2), (3, 4)])) == [2,4,1,9]

  @resumable function test_comprehension2()
    x = 2
    y = 3
    @yield [ x + y for x in 1:y, y in 1:x]
  end
  @test collect(test_comprehension2()) == [[2 3; 3 4; 4 5]]

  @resumable function test_comprehension3()
    x = 2
    y = 3
    @yield [ x + y for x in 1:x, y in 1:y]
  end
  @test collect(test_comprehension3()) == [[2 3 4; 3 4 5]]

  @resumable function test_comprehension4()
    x = 2
    y = 3
    u = [  x + y for x in 1:y for y in 1:x]
    for k in u
      @yield k
    end
  end
  @test collect(test_comprehension4()) == [2, 3, 4, 4, 5, 6]

  @resumable function test_comprehension5()
    x = 2
    y = 3
    u = [  x + y for x in 1:x for y in 1:y]
    for k in u
      @yield k
    end
  end
  @test collect(test_comprehension5()) == [2, 3, 4, 3, 4, 5]

  @resumable function test_comprehension_state()
    c = 1
    @yield [i*c for i in 1:5]
    c += 1
    @yield [i*c for i in 1:5]
  end
  @test_broken collect(test_comprehension_state()) == [[1, 2, 3, 4, 5], [2, 4, 6, 8, 10]]

  @resumable function test_comprehension_if()
    @yield [i for i in 1:10 if i < 5]
  end
  @test collect(test_comprehension_if()) == [[1, 2, 3, 4]]

  @resumable function test_comprehension_if_multi_iterators()
    @yield [i + j for i in 1:3, j in 1:3 if i <= j]
  end
  @test collect(test_comprehension_if_multi_iterators()) == [[2, 3, 4, 4, 5, 6]]

  @resumable function test_comprehension_if_nested_for()
    @yield [i * j for i in 1:3 for j in 1:3 if i * j < 5]
  end
  @test collect(test_comprehension_if_nested_for()) == [[1, 2, 3, 2, 4, 3]]

  @resumable function test_comprehension_if_mixed()
    @yield [i + j + k for i in 1:2, j in 1:2 for k in 1:2 if i + j + k == 4]
  end
  @test collect(test_comprehension_if_mixed()) == [[4, 4, 4]]

  @resumable function test_comprehension_if_state()
    c = 1
    @yield [i for i in 1:10 if i < c]
    c += 1
    @yield [i for i in 1:10 if i < c]
  end
  @test_broken collect(test_comprehension_if_state()) == [Int[], [1]]
end

@testset "test_ref" begin
  @resumable function test_ref(x)
    y = x
    a = [i^2 for i in 1:3]
    for i in 1:3
      y[] = a[i]
      @yield y[]
    end
  end
  @test collect(test_ref(Ref(1))) == [1,4,9]
end

@testset "test_getproperty" begin
  @resumable function test_getproperty()
    let
      node = (a = 1, b = 2)
      v = [[2], node]
      let node = (a = 2, b = 1)
        (v[node.a])[node.b] == 3
      end
      @yield v
    end
  end

  @test collect(test_getproperty()) == [[[2], (a = 1, b = 2)]]
end

@testset "test_weird_for" begin
  @resumable function test_weird_for(n)
    for i=1:n, j=1:i
      @yield i, j
    end
  end
  @test collect(test_weird_for(3)) == [(1, 1), (2, 1), (2, 2), (3, 1), (3, 2), (3, 3)]
end
end

using ResumableFunctions
using Test

@resumable function fibonacci_resumable(n::Int)
  a, b = zero(Int), one(Int)
  for _ in 1:n
    @yield a
    a, b = b, a + b
  end
end

@noinline function test_resumable(n::Int)
  a = 0
  for v in fibonacci_resumable(n)
    a = v
  end
  a
end

@test (@allocated test_resumable(80))==0


@resumable function cumsum(iter)
  acc = zero(eltype(iter))
  for i in iter
    acc += i
    @yield acc
  end
end

# versions that support generating inferred code
if VERSION >= v"1.10.0-DEV.873"
  cs = cumsum(1:1000)
  @allocated cs() # shake out the compilation overhead
  @test (@allocated cs())==0
end

using ExplicitImports
using ResumableFunctions
using Test

@testset "ExplicitImports tests" begin
    @test check_no_implicit_imports(ResumableFunctions) === nothing
    @test_broken check_no_stale_explicit_imports(ResumableFunctions) === nothing
    @test check_all_explicit_imports_via_owners(ResumableFunctions) === nothing

    # MacroTools.jl has been inconsistent in marking documented functions as public (or exporting them), 
    # gradually doing different ones over different versions. So work around that.
    nonpublic_ignore = ()
    macrotools_module = @eval(ResumableFunctions,
        only(filter((k, v)::Pair -> k.name == "MacroTools", Base.loaded_modules)).second)
    if pkgversion(macrotools_module) < v"0.5.10"
        nonpublic_ignore = (:flatten, :postwalk, :striplines, :combinedef, :combinearg)
    elseif pkgversion(macrotools_module) < v"0.5.17"
        nonpublic_ignore = (:flatten, :postwalk, :striplines)
    end
    #@test check_all_explicit_imports_are_public(ResumableFunctions; ignore=nonpublic_ignore) === []

    @test check_all_qualified_accesses_via_owners(ResumableFunctions;
        skip=(Base => Core, Core.Compiler => Base)) === nothing
end

# safe logging, copied from GPUCompiler

using Logging: Logging, @debug, @info, @warn, @error, LogLevel, global_logger

# Prevent invalidation when packages define custom loggers
# Using invoke in combination with @nospecialize eliminates backedges to these methods
function _invoked_min_enabled_level(@nospecialize(logger))
    return invoke(Logging.min_enabled_level, Tuple{typeof(logger)}, logger)::LogLevel
end

# define safe loggers for use in generated functions (where task switches are not allowed)
for level in [:debug, :info, :warn, :error]
    @eval begin
        macro $(Symbol("safe_$level"))(ex...)
            macrocall = :(@placeholder $(ex...) _file=$(String(__source__.file)) _line=$(__source__.line))
            # NOTE: `@placeholder` in order to avoid hard-coding @__LINE__ etc
            macrocall.args[1] = Symbol($"@$level")
            quote
                io = IOContext(Core.stderr, :color=>get(stderr, :color, false))
                # ideally we call Logging.shouldlog() here, but that is likely to yield,
                # so instead we rely on the min_enabled_level of the logger.
                # in the case of custom loggers that may be an issue, because,
                # they may expect Logging.shouldlog() getting called, so we use
                # the global_logger()'s min level which is more likely to be usable.
                min_level = _invoked_min_enabled_level(global_logger())
                safe_logger = Logging.ConsoleLogger(io, min_level)
                # using with_logger would create a closure, which is incompatible with
                # generated functions, so instead we reproduce its implementation here
                safe_logstate = Base.CoreLogging.LogState(safe_logger)
                @static if VERSION < v"1.11-"
                    t = current_task()
                    old_logstate = t.logstate
                    try
                        t.logstate = safe_logstate
                        $(esc(macrocall))
                    finally
                        t.logstate = old_logstate
                    end
                else
                    Base.ScopedValues.@with(
                        Base.CoreLogging.CURRENT_LOGSTATE => safe_logstate, $(esc(macrocall))
                    )
                end
            end
        end
    end
end

# Manual

```@meta
DocTestSetup = quote
  using ResumableFunctions
end
```

## Basic usage

When a `@resumable function` is called, it continues where it left during the previous invocation:

```jldoctest basic-example; output=false
@resumable function basic_example()
  @yield "Initial call"
  @yield "Second call"
  "Final call"
end
# output
basic_example (generic function with 1 method)
```

```jldoctest basic-example
julia> basic_iterator = basic_example();

julia> basic_iterator()
"Initial call"

julia> basic_iterator()
"Second call"

julia> basic_iterator()
"Final call"
```

The `@yield` can also be used without a return argument:

```jldoctest yield-example; output=false
@resumable function yield_example()
  @yield "Initial call"
  @yield
  "Final call"
end
# output
yield_example (generic function with 1 method)
```

```jldoctest yield-example
julia> yield_iterator = yield_example();

julia> yield_iterator()
"Initial call"

julia> yield_iterator()

julia> yield_iterator()
"Final call"
```

The famous Fibonacci sequence can easily be generated:

```jldoctest fibonacci; output=false
@resumable function fibonacci()
  a = 0
  b = 1
  while true
    @yield a
    a, b = b, a + b
  end
end
# output
fibonacci (generic function with 1 method)
```

```jldoctest fibonacci
julia> fib_iterator = fibonacci();

julia> fib_iterator()
0

julia> fib_iterator()
1

julia> fib_iterator()
1

julia> fib_iterator()
2

julia> fib_iterator()
3

julia> fib_iterator()
5

julia> fib_iterator()
8
```

The `@resumable function` can take arguments and the type of the return value can be specified:

```jldoctest fibo-rettype; output=false
@resumable function fibonacci(n) :: Int
  a = 0
  b = 1
  for i in 1:n
    @yield a
    a, b = b, a + b
  end
end
# output
fibonacci (generic function with 1 method)
```

```jldoctest fibo-rettype
julia> fib_iterator = fibonacci(4);

julia> fib_iterator()
0

julia> fib_iterator()
1

julia> fib_iterator()
1

julia> fib_iterator()
2

julia> fib_iterator()

julia> fib_iterator()
ERROR: @resumable function has stopped!
```

When the `@resumable function` returns normally (i.e. at the end of the function rather than at a `@yield` point), an error will be thrown if called again.

## Two-way communication

The caller can transmit a variable to the `@resumable function` by assigning a `@yield` statement to a variable:

```jldoctest two-way; output=false
@resumable function two_way()
  name = @yield "Who are you?"
  "Hello, " * name * "!"
end
# output
two_way (generic function with 1 method) 
```

```jldoctest two-way
julia> hello = two_way();

julia> hello()
"Who are you?"

julia> hello("Ben")
"Hello, Ben!"
```

When an `Exception` is passed to the `@resumable function`, it is thrown at the resume point:

```jldoctest exception-pass; output=false
@resumable function mouse()
  try
    @yield "Here I am!"
  catch exc
    return "You got me!"
  end
end

struct Cat <: Exception end
# output

```

```jldoctest exception-pass
julia> catch_me = mouse();

julia> catch_me()
"Here I am!"

julia> catch_me(Cat())
"You got me!"
```

## Iterator interface

The iterator interface is implemented for a `@resumable function`:

```jldoctest iterate; output=false
@resumable function fibonacci(n) :: Int
  a = 0
  b = 1
  for i in 1:n
    @yield a
    a, b = b, a + b
  end
end
# output
fibonacci (generic function with 1 method)
```

```jldoctest iterate
julia> for val in fibonacci(10) println(val) end
0
1
1
2
3
5
8
13
21
34
```

## Parametric `@resumable` functions

Type parameters can be specified with a normal Julia `where` clause:

```jldoctest parametric; output=false
@resumable function fibonacci(a::N, b::N=a+one(N)) :: N where {N<:Number}
  for i in 1:10
    @yield a
    a, b = b, a + b
   end
end
# output
fibonacci (generic function with 2 methods)
```

```jldoctest parametric
julia> for val in fibonacci(0.0) println(val) end
0.0
1.0
1.0
2.0
3.0
5.0
8.0
13.0
21.0
34.0
```

## Caveats

- In a `try` block only top level `@yield` statements are allowed.
- In a `catch` or a `finally` block a `@yield` statement is not allowed.
- An anonymous function can not contain a `@yield` statement.
- If a `FiniteStateMachineIterator` object is used in more than one `for` loop, only the `state` variable is reinitialised. A `@resumable function` that alters its arguments will use the modified values as initial parameters.

---
title: 'ResumableFunctions: C# sharp style generators for Julia.'
tags:
  - semi-coroutine
  - finite-state-machine
  - julia
  - iterator
  - stackless
authors:
 - name: Ben Lauwens
   orcid: 0000-0003-0761-6265
   affiliation: 1
affiliations:
 - name: Royal Military Academy, Brussels, Belgium
   index: 1
date: September 2017
bibliography: paper.bib
---

# Summary

C# has a convenient way to create iterators [@CsharpIterators] using the `yield return` statement. The package [@ResumableFunctions] provides the same functionality for the Julia language [@Julia] by introducing the `@resumable` and the `@yield` macros. These macros can be used to replace the `Task` switching functions `produce` and `consume` which were deprecated in Julia v0.6. `Channels` are the preferred way for inter-task communication in julia v0.6+, but their performance is subpar for iterator applications.

The macro `@resumable` transform a function definition into a finite state-machine, i.e. a callable type holding the state and references to the internal variables of the function and a constructor for this new type respecting the method signature of the original function definition. When calling the new type a modified version of the body of the original function definition is executed:
  - a dispatch mechanism is inserted at the start to allow a non local jump to a label inside the body;
  - the `@yield` statement is replaced by a `return` statement and a label placeholder as endpoint of a non local jump;
  - `for` loops are transformed in `while` loops and
  - `try`-`catch`-`finally`-`end` expressions are converted in a sequence of `try`-`catch`-`end` expressions with at the end of the `catch` part a non local jump to a label that marks the beginning of the expressions in the `finally` part.
The two last transformations are needed to overcome the limitations of the non local jump macros `@goto` and `@label`.

Straightforward two-way communication between the caller and the callable type is possible by calling the callable type with an extra argument. The value of this argument is passed to the left side of an `arg = @yield ret` expression.

The `iterator` interface is implemented so that a `@resumable function` can be used transparently.

Benchmarks show that this macro based implementation of semi-coroutines is an order of magnitude faster than both the original `Task` switching with `produce` and `consume` and the newer `Channel` based approach for inter-task communication. A context switch is more expensive than a function call.

The next generation of process-driven simulations in the discrete-event simulation framework [@SimJulia] is based on this package.

# References

# ResumableFunctions

*C# style generators a.k.a. semi-coroutines for Julia.*

C# has a convenient way to create iterators using the `yield return` statement. The package `ResumableFunctions` provides the same functionality for the Julia language by introducing the `@resumable` and the `@yield` macros. These macros can be used to replace the `Task` switching functions `produce` and `consume` which were deprecated in Julia v0.6. `Channels` are the preferred way for inter-task communication in julia v0.6+, but their performance is subpar for iterator applications.

## Example

```jldoctest
using ResumableFunctions

@resumable function fibonacci(n::Int)
  a = 0
  b = 1
  for i in 1:n
    @yield a
    a, b = b, a+b
  end
end

for val in fibonacci(10) 
  println(val) 
end

# output

0
1
1
2
3
5
8
13
21
34
```

## Installation

`ResumableFunctions` is a registered package and can be installed by running:
```julia
using Pkg
Pkg.add("ResumableFunctions")
```

## Authors

* Ben Lauwens, Royal Military Academy, Brussels, Belgium.
* JuliaDynamics and QuantumSavory volunteers.

## License

`ResumableFunctions` is licensed under the MIT "Expat" License.

# Internals

The macro `@resumable` transforms a function definition into a finite state-machine, i.e.
  * a callable type holding the state and references to the internal variables of the function,  and
  * a constructor for this new type respecting the method signature of the original function definition. 

When calling an instance of this new type, a modified version of the body of the original function definition is executed:
  - a dispatch mechanism is inserted at the start to allow a non-local jump to a label inside the body;
  - the `@yield` statement is replaced by a `return` statement and a label placeholder as endpoint of a non-local jump;
  - `for` loops are transformed into `while` loops; and
  - `try`-`catch`-`finally`-`end` expressions are converted into a sequence of `try`-`catch`-`end` expressions; at the end of the `catch` part, a non-local jump is inserted to a label that marks the beginning of the expressions in the `finally` part.

The last two transformations are needed to overcome the limitations of the non-local jump macros `@goto` and `@label`.

The complete procedure is explained using the following example:

```julia
@resumable function fibonacci(n::Int)
  a = 0
  b = 1
  for i in 1:n-1
    @yield a
    a, b = b, a + b
  end
  a
end
```

## Split the definition

The function definition is split by `MacroTools.splitdef` in different parts, eg. `:name`, `:body`, `:args`, ...

## For loops

`for` loops in the body of the function definition are transformed into equivalent `while` loops:

```julia
begin
  a = 0
  b = 1
  _iter = 1:n-1
  state = iterate(_iter)
  while state !== nothing
    i, _iterstate = state
    @yield a
    a, b = b, a + b
    state = iterate(_iter, _iterstate)
  end
  a
end
```

## Slots

The slots and their types in the function definition are recovered by running the `code_typed` function for the locally evaluated function definition:

```julia
n :: Int64
a :: Int64
b :: Int64
_iter :: UnitRange{Int64}
_iterstate :: Int64
i :: Int64
```

## Type definition

A `mutable struct` is defined containing the state and the slots:

```julia
mutable struct ##123 <: ResumableFunctions.FiniteStateMachineIterator
      _state :: UInt8
      n :: Int64
      a :: Int64
      b :: Int64
      _iter :: UnitRange{Int64}
      _iterstate :: Int64
      i :: Int64 

      function ##123()
        fsmi = new()
        fsmi._state = 0x00
        fsmi
      end
    end
```

## Caller definition

A caller function is constructed that creates the previously defined composite type. This function satisfies the calling convention of the original function definition and is returned from the macro:

```julia
function fibonacci(n::Int)
  fsmi = ##123(n)
  fsmi.n = n
  fsmi
end
```

## Transformation of the body

In 6 steps the body of the function definition is transformed into a finite state-machine:

### Renaming of slots

The slots are replaced by references to the fields of the composite type:

```julia
begin
  _fsmi.a = 0
  _fsmi.b = 1
  _fsmi._iter = 1:n-1
  state = iterate(_fsmi._iter)
  while state !== nothing
    _fsmi.i, _fsmi._iterstate = state
    @yield _fsmi.a
    _fsmi.a, _fsmi.b = _fsmi.b, _fsmi.a + _fsmi.b
    state = iterate(_fsmi._iter, _fsmi._iterstate)
  end
  _fsmi.a
end
```

### Two-way communication

All expressions of the form `_fsmi.arg = @yield` are transformed into:

```julia
@yield
_fsmi.arg = _arg
```

### Exception handling

Exception handling is added to `@yield`:

```julia
begin
  _fsmi.a = 0
  _fsmi.b = 1
  _fsmi._iter = 1:n-1
  state = iterate(_fsmi._iter)
  while state !== nothing
    _fsmi.i, _fsmi._iterstate = state
    @yield _fsmi.a
    _arg isa Exception && throw(_arg)
    _fsmi.a, _fsmi.b = _fsmi.b, _fsmi.a + _fsmi.b
    state = iterate(_fsmi._iter, _fsmi._iterstate)
  end
  _fsmi.a
end
```

### Try catch finally end block handling

`try`-`catch`-`finally`-`end` expressions are converted into a sequence of `try`-`catch`-`end` expressions; at the end of the `catch` part, a non-local jump is inserted to a label that marks the beginning of the expressions in the `finally` part.

### Yield transformation

The `@yield` statement is replaced by a `return` statement and a label placeholder as target of a non-local jump:

```julia
begin
  _fsmi.a = 0
  _fsmi.b = 1
  _fsmi._iter = 1:n-1
  state = iterate(_fsmi._iter)
  while state !== nothing
    _fsmi.i, _fsmi._iterstate = state
    _fsmi._state = 0x01
    return _fsmi.a
    @label _STATE_1
    _fsmi._state = 0xff
    _arg isa Exception && throw(_arg)
    _fsmi.a, _fsmi.b = _fsmi.b, _fsmi.a + _fsmi.b
    state = iterate(_fsmi._iter, _fsmi._iterstate)
  end
  _fsmi.a
end
```

### Dispatch mechanism

A dispatch mechanism is inserted at the start of the body to allow a non-local jump to a label inside the body:

```julia
begin
  _fsmi._state == 0x00 && @goto _STATE_0
  _fsmi._state == 0x01 && @goto _STATE_1
  error("@resumable function has stopped!")
  @label _STATE_0
  _fsmi._state = 0xff
  _arg isa Exception && throw(_arg)
  _fsmi.a = 0
  _fsmi.b = 1
  _fsmi._iter = 1:n-1
  state = iterate(_fsmi._iter)
  while state !== nothing
    _fsmi.i, _fsmi._iterstate = state
    _fsmi._state = 0x01
    return _fsmi.a
    @label _STATE_1
    _fsmi._state = 0xff
    _arg isa Exception && throw(_arg)
    _fsmi.a, _fsmi.b = _fsmi.b, _fsmi.a + _fsmi.b
    state = iterate(_fsmi._iter, _fsmi._iterstate)
  end
  _fsmi.a
end
```

## Making the type callable

A function is defined with the above code as its body, accepting one argument `_arg`:

```julia
function (_fsmi::##123)(_arg::Any=nothing)
  _fsmi_state == 0x00 && @goto _STATE_0
  _fsmi_state == 0x01 && @goto _STATE_1
  error("@resumable function has stopped!")
  @label _STATE_0
  _fsmi._state = 0xff
  _arg isa Exception && throw(_arg)
  _fsmi.a = 0
  _fsmi.b = 1
  _fsmi._iter = 1:n-1
  state = iterate(_fsmi._iter)
  while state !== nothing
    _fsmi.i, _fsmi._iterstate = state
    _fsmi._state = 0x01
    return _fsmi.a
    @label _STATE_1
    _fsmi._state = 0xff
    _arg isa Exception && throw(_arg)
    _fsmi.a, _fsmi.b = _fsmi.b, _fsmi.a + _fsmi.b
    state = iterate(_fsmi._iter, _fsmi._iterstate)
  end
  _fsmi.a
end
```
